<template>
<div class="menu">
	<lobby
		v-on:start="startGame"
		:hosting="false"
		:local="true"
		:map="this.map"
		:messages="this.messages"
		:mode="this.mode"
		:players="this.players"
		:teams="this.teams"
		:teamsize="this.max_players"
	/>
</div>
</template>

<script>
// Component
import Lobby from "../components/Lobby.vue"

// Constants
import { FLOOR_MAP_CITADEL } from "../../constants/tower.js"
import {
	BODY_MESHES,
	DEFAULT_BODY,
	DEFAULT_WHEEL,
	WHEEL_MESHES
} from "../../constants/car.js"

export default {
	components: { Lobby },
	computed: {
		map () {
			if (!Settings.get("LOCAL_MAP")) Settings.set("LOCAL_MAP", "default")
			return Settings.get("LOCAL_MAP")
		},
		mode () {
			if (!Settings.get("LOCAL_MODE")) Settings.set("LOCAL_MODE", "grid-control")
			return Settings.get("LOCAL_MODE")
		},
		players () {
			return Input.list.map((input, key) => {
				return {
					control: input.type === "key" ? "key" : input.number,
					id: key,
					name: input.type === "key" ? "Keyboard" : `Controller ${input.number + 1}`
				}
			})
		},
		teams () {
			if (!Settings.get("LOCAL_TEAMS")) Settings.set("LOCAL_TEAMS", "GAME_2v2")
			return Settings.get("LOCAL_TEAMS")
		}
	},
	data () {
		return {
			max_players: 4,
			messages: []
		}
	},
	methods: {
		startGame (data) {
			UI.emit("CHANGE_ROUTE", "/")

			const conf = Settings.get("CAR_CONFIGURATION")

			StateManager.change(States.LocalGame, [{
				map: Maps[Settings.get("LOCAL_MAP")],
				players: data.players.map((player) => {
					const is_ai = player.is_ai

					const body = is_ai ? DEFAULT_BODY : conf[player.id].body
					const wheel = is_ai ? DEFAULT_WHEEL : conf[player.id].wheel

					return {
						ai: is_ai,
						body,
						control: !is_ai ? player.control : undefined,
						name: player.name,
						wheel
					}
				})
			}])
		}
	},
	mounted () {
		Tower.goToFloor(FLOOR_MAP_CITADEL)
	},
	name: "local-lobby-state",
	props: [ "id" ]
}
</script>

<style lang="less" scoped>
@import "./styles/Menu.less";

.menu {
	width: 60em;
}

.lobby-state {
	font-size: 4em;
}
</style>
